/**
 * Akeeba Remote Control
 * A utility to remotely control Akeeba Backup and Admin Tools
 * 
 * @version $Id$
 * @copyright 2008-2010 Nicholas K. Dionysopoulos / AkeebaBackup.com
 * @license GNU/GPL v3 or later
 */

/**
 * Displays the Site Log Viewer dialog
 */
function siteLogViewerShow()
{
	uuid = akeeba_remote_selected_sites[0];
	
	// Show the dialog and attach the button events
	$('#siteLogViewer').dialog({
		title: 'Log Viewer',
		autoOpen: true,
		buttons: {
			'OK': function(){
				$(this).dialog('close');
			},
			'Save': function(){
				siteLogViewerSave();
			},
			'Copy': function(){
				siteLogViewerCopy();
			}
		},
		draggable: false,
		height: ($('body').height() - 40),
		width: ($('body').width() - 40),
		modal: true,
		open: function(event,ui){
			var siteSelector = '#site-' + uuid;
			var akeebaAPI = $(siteSelector).data('akeeba_api_object');	
			$('#siteLogData').text( akeebaAPI.getLog() );
		}
	});
}

/**
 * Returns the contents of the log file to be saved
 */
function siteLogGetContents()
{
	var contents = '';
	var siteSelector = '#site-' + uuid;
	var akeebaAPI = $(siteSelector).data('akeeba_api_object');
	var logText = akeebaAPI.getLog();
	var p = Titanium.Platform;
	contents += '!! IMPORTANT !!! IMPORTANT !!! IMPORTANT !!! IMPORTANT !!! IMPORTANT !!! IMPORTANT !!! IMPORTANT !!\n';
	contents += '\n';
	contents += 'Please ZIP and attach this log file with your support requests concerning Akeeba Remote Control.\n';
	contents += 'Support requests without this log file or with a log file which is not inside a ZIP archive will\n';
	contents += 'result in us telling you to do exactly that: ZIP and attach the log file. We can not help you\n';
	contents += 'otherwise. Do not waste your time, just ZIP and attach the log file. If you still do not get it,\n';
	contents += 'please, pretty please, ZIP and attach the log file if you want us to help you. Thank you!\n';
	contents += '\n';
	contents += '!! IMPORTANT !!! IMPORTANT !!! IMPORTANT !!! IMPORTANT !!! IMPORTANT !!! IMPORTANT !!! IMPORTANT !!\n';
	contents += '\n';
	contents += '\n';
	contents += '--- START OF RAW LOG ---\n';
	contents += '================================================================================\n';
	contents += Titanium.API.Application.getName() + ' version ' + Titanium.API.Application.getVersion() + '\n';
	contents += '================================================================================\n';
	contents += 'Titanium runtime: ' + Titanium.getVersion() + ' on ' + Titanium.getPlatform() + '\n';
	contents += 'Platform info: ' + p.getName() + ' ' + p.getVersion() + ' (' + p.getArchitecture() + ' / ' + p.getOSType() + ') -- Processor(s): ' + p.getProcessorCount() + '\n';
	contents += 'Interfacing Akeeba Backup ' + akeebaAPI.versionCache.component + ' (' + akeebaAPI.versionCache.date + ')\n';
	contents += '================================================================================\n';
	contents += logText + '\n';
	contents += '================================================================================\n';
	contents += '--- END OF RAW LOG ---';
	return contents;
}

function siteLogViewerSave()
{
	var props = {
			title: 'Save the raw log file',
			types: ['txt'],
			multiple: false
	};
	Titanium.UI.currentWindow.openSaveAsDialog(function(f)
	{
		if (f.length) {
			var filename = f[0];
			var filestream = Titanium.Filesystem.getFileStream(filename);
			filestream.open(Titanium.Filesystem.MODE_WRITE, false, false);
			var contents = siteLogGetContents();
			filestream.write( contents );
			filestream.close();
			alert( sprintf(Trans.t('LOGSAVEDAS'), filename) );
		} else {
			alert(Trans.t('LOGSAVEABORTED'));
		}
	},
	props);	
}

function siteLogViewerCopy()
{
	var contents = siteLogGetContents();
	Titanium.UI.Clipboard.setText( contents );
	alert(Trans.t('LOGCOPIED'));
}