/**
 * Akeeba Remote Control
 * A utility to remotely control Akeeba Backup and Admin Tools
 * 
 * @version $Id$
 * @copyright 2008-2010 Nicholas K. Dionysopoulos / AkeebaBackup.com
 * @license GNU/GPL v3 or later
 */

/**
 * Creates a Type 4 UUID as per RFC4122. Credit's due where credit's due:
 * http://www.broofa.com/Tools/Math.uuid.js Respect to Robert Kieffer for
 * this awesome block of PHP code!
 * @return
 */
function createUUID()
{
	return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
	      var r = Math.random()*16|0, v = c == 'x' ? r : (r&0x3|0x8);
	      return v.toString(16);
	    }).toUpperCase();
}

/**
 * A quick'n'dirty function to format a byte size as B, KB, MB, GB or TB.
 * For example, formatBytes(1509950) = '1.44 MB'
 * @param size
 * @return
 */
function formatBytes(size)
{
	var divisor = 1;
	var uom = 'B';
	
	if(size >= 1099511627776) {
		divisor = 1099511627776;
		uom = 'TB';
	} else if(size >= 1073741824) {
		divisor = 1073741824;
		uom = 'GB';
	} else if(size >= 1048576) {
		divisor = 1048576;
		uom = 'MB';
	} else if(size >= 1024) {
		divisor = 1024;
		uom = 'KB';
	}
	
	return sprintf('%1.2f', size / divisor) + ' ' + uom;
}